"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QueryList = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _createStylingFromTheme = require("../styles/createStylingFromTheme");

var _rtkQuery = require("../utils/rtk-query");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var QueryList = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2.default)(QueryList, _PureComponent);

  var _super = _createSuper(QueryList);

  function QueryList() {
    (0, _classCallCheck2.default)(this, QueryList);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(QueryList, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          resInfos = _this$props.resInfos,
          selectedQueryKey = _this$props.selectedQueryKey,
          onSelectQuery = _this$props.onSelectQuery;
      return /*#__PURE__*/_react.default.createElement(_createStylingFromTheme.StyleUtilsContext.Consumer, null, function (_ref) {
        var styling = _ref.styling;
        return /*#__PURE__*/_react.default.createElement("ul", styling('queryList'), resInfos.map(function (resInfo) {
          var isSelected = (0, _rtkQuery.isQuerySelected)(selectedQueryKey, resInfo);
          return /*#__PURE__*/_react.default.createElement("li", (0, _extends2.default)({
            key: resInfo.queryKey,
            onClick: function onClick() {
              return onSelectQuery(resInfo);
            }
          }, styling(['queryListItem', isSelected && 'queryListItemSelected'], isSelected)), /*#__PURE__*/_react.default.createElement("p", styling('queryListItemKey'), QueryList.formatQuery(resInfo)), /*#__PURE__*/_react.default.createElement("div", styling('queryStatusWrapper'), /*#__PURE__*/_react.default.createElement("strong", styling(['queryStatus', 'queryType']), resInfo.type === 'query' ? 'Q' : 'M'), /*#__PURE__*/_react.default.createElement("p", styling('queryStatus'), resInfo.state.status)));
        }));
      });
    }
  }], [{
    key: "isItemSelected",
    value: function isItemSelected(selectedQueryKey, queryInfo) {
      return !!selectedQueryKey && selectedQueryKey.queryKey === queryInfo.queryKey && selectedQueryKey.reducerPath === queryInfo.reducerPath;
    }
  }, {
    key: "formatQuery",
    value: function formatQuery(resInfo) {
      var _resInfo$state$endpoi;

      var key = resInfo.type === 'query' ? resInfo.queryKey : "".concat((_resInfo$state$endpoi = resInfo.state.endpointName) !== null && _resInfo$state$endpoi !== void 0 ? _resInfo$state$endpoi : '', " ").concat(resInfo.queryKey);
      return key;
    }
  }]);
  return QueryList;
}(_react.PureComponent);

exports.QueryList = QueryList;