import { RtkResourceInfo, SelectOption } from '../types';
export interface Comparator<T> {
    (a: T, b: T): number;
}
export declare enum QueryComparators {
    fulfilledTimeStamp = "timestamp",
    queryKey = "key",
    status = "status",
    endpointName = "endpointName",
    apiReducerPath = "apiReducerPath"
}
export declare const sortQueryOptions: SelectOption<QueryComparators>[];
export declare function compareJSONPrimitive<T extends string | number | boolean | null>(a: T, b: T): number;
export declare const queryComparators: Readonly<Record<QueryComparators, Comparator<RtkResourceInfo>>>;
